diff --git a/libstdc++-v3/testsuite/27_io/basic_istringstream/cons/2020.cc b/libstdc++-v3/testsuite/27_io/basic_istringstream/cons/2020.cc
index 7b475abe1e0..dc2c5f0be73 100644
--- a/libstdc++-v3/testsuite/27_io/basic_istringstream/cons/2020.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_istringstream/cons/2020.cc
@@ -1,4 +1,4 @@
-// 1999-01-17 bkoz test functionality of basic_filebuf for char_type == char
+// 1999-01-17 bkoz test functionality of basic_istringstream for char_type == char
 
 // Copyright (C) 1997-2024 Free Software Foundation, Inc.
 //
@@ -17,8 +17,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// 27.8.1.1 - Template class basic_istringstream
+// NB: This file is for testing basic_istringstream with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/27_io/basic_istringstream/requirements/base_classes.cc b/libstdc++-v3/testsuite/27_io/basic_istringstream/requirements/base_classes.cc
index c9ccf66f7a1..03778a43757 100644
--- a/libstdc++-v3/testsuite/27_io/basic_istringstream/requirements/base_classes.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_istringstream/requirements/base_classes.cc
@@ -18,7 +18,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
+// 27.8.1.1 - Template class basic_istringstream
 
 #include <istream>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/27_io/basic_ostringstream/cons/2020.cc b/libstdc++-v3/testsuite/27_io/basic_ostringstream/cons/2020.cc
index 95e89a9d08e..5a398af30d9 100644
--- a/libstdc++-v3/testsuite/27_io/basic_ostringstream/cons/2020.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_ostringstream/cons/2020.cc
@@ -1,4 +1,4 @@
-// 1999-01-17 bkoz test functionality of basic_filebuf for char_type == char
+// 1999-01-17 bkoz test functionality of basic_ostringstream for char_type == char
 
 // Copyright (C) 1997-2024 Free Software Foundation, Inc.
 //
@@ -17,8 +17,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// 27.8.1.1 - Template class basic_ostringstream
+// NB: This file is for testing basic_ostringstream with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/27_io/basic_ostringstream/requirements/base_classes.cc b/libstdc++-v3/testsuite/27_io/basic_ostringstream/requirements/base_classes.cc
index 07b58727563..58a78a2d44b 100644
--- a/libstdc++-v3/testsuite/27_io/basic_ostringstream/requirements/base_classes.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_ostringstream/requirements/base_classes.cc
@@ -18,7 +18,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
+// 27.8.1.1 - Template class basic_ostringstream
 
 #include <ostream>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/27_io/basic_stringbuf/cons/2020.cc b/libstdc++-v3/testsuite/27_io/basic_stringbuf/cons/2020.cc
index 0e23fd8b40f..17b19578cd4 100644
--- a/libstdc++-v3/testsuite/27_io/basic_stringbuf/cons/2020.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_stringbuf/cons/2020.cc
@@ -1,4 +1,4 @@
-// 1999-01-17 bkoz test functionality of basic_filebuf for char_type == char
+// 1999-01-17 bkoz test functionality of basic_stringbuf for char_type == char
 
 // Copyright (C) 1997-2024 Free Software Foundation, Inc.
 //
@@ -18,7 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // 27.7.1 - Template class basic_stringbuf
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// NB: This file is for testing basic_stringbuf with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/2.cc b/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/2.cc
index 046b9ab0ebf..0695a4d3ad4 100644
--- a/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/2.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/2.cc
@@ -1,5 +1,5 @@
 // { dg-do compile }
-// 1999-01-17 bkoz test functionality of basic_filebuf for char_type == char
+// 1999-01-17 bkoz test functionality of basic_stringbuf for char_type == char
 
 // Copyright (C) 1997-2024 Free Software Foundation, Inc.
 //
@@ -19,7 +19,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // 27.7.1 - Template class basic_stringbuf
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// NB: This file is for testing basic_stringbuf with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
@@ -38,11 +38,3 @@ namespace std
 
 // more surf!!!
 
-
-
-
-
-
-
-
-
diff --git a/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/4.cc b/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/4.cc
index 4c8d763caa5..38268eeaf7f 100644
--- a/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/4.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_stringbuf/requirements/explicit_instantiation/4.cc
@@ -19,7 +19,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // 27.7.1 - Template class basic_stringbuf
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// NB: This file is for testing basic_stringbuf with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/27_io/basic_stringstream/cons/2020.cc b/libstdc++-v3/testsuite/27_io/basic_stringstream/cons/2020.cc
index eca80dcc555..cd24e8a80ea 100644
--- a/libstdc++-v3/testsuite/27_io/basic_stringstream/cons/2020.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_stringstream/cons/2020.cc
@@ -1,4 +1,4 @@
-// 1999-01-17 bkoz test functionality of basic_filebuf for char_type == char
+// 1999-01-17 bkoz test functionality of basic_stringstream for char_type == char
 
 // Copyright (C) 1997-2024 Free Software Foundation, Inc.
 //
@@ -17,8 +17,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
-// NB: This file is for testing basic_filebuf with NO OTHER INCLUDES.
+// 27.8.1.1 - Template class basic_stringstream
+// NB: This file is for testing basic_stringstream with NO OTHER INCLUDES.
 
 #include <sstream>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/27_io/basic_stringstream/requirements/base_classes.cc b/libstdc++-v3/testsuite/27_io/basic_stringstream/requirements/base_classes.cc
index 8cdc9010f4c..5ad30513c9e 100644
--- a/libstdc++-v3/testsuite/27_io/basic_stringstream/requirements/base_classes.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_stringstream/requirements/base_classes.cc
@@ -18,7 +18,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 27.8.1.1 - Template class basic_filebuf 
+// 27.8.1.1 - Template class basic_stringstream
 
 #include <iostream>
 #include <sstream>